<template src="./show.htm"></template>

<script>

    import Vue from 'vue';
    import GetEntityMixin from '../../../mixins/entities/getEntityMixin.js';
    import { breadcrumbsMixin } from '../../../mixins/breadcrumbsMixin.js';
    import HandleEntityMixin from '../../../mixins/entities/handleEntityMixin.js';
    import ValidationErrorsMixin from '../../../mixins/validationErrorsMixin.js';

    import ShowInfoComponent from './components/info/ShowInfoComponent.vue';
    import ShowProductsComponent from './components/products/ShowProductsComponent.vue';

    Vue.component('show-info', ShowInfoComponent);
    Vue.component('show-products', ShowProductsComponent);

    export default {

        mounted() {

            this.getEntityMixin('orders', this.$route.params.id, 'setFinalOrder', false);
        },

        data() {

            return {

            }
        },

        mixins: [
            GetEntityMixin,
            breadcrumbsMixin,
            HandleEntityMixin,
            ValidationErrorsMixin
        ],

        methods: {

            /**
             *
             */
            finalizeOrder(action) {

                this.handleEntity('order', action, route('admin.orders.finalize', this.$route.params.id));
            },


            /**
             * Create request order object.
             */
            createEntityRequestObject() {

                return createRequestObject(this.$store.getters.getFinalOrderRequestObject);
            },


            /**
             * Remove all saved attributes data from order.
             */
            removeFinalOrder() {

                this.$store.dispatch('setDefaultFinalOrder')
            }
        },

        computed: {

            /**
             * Get currently brand from store.
             */
            finalOrder() {

                return this.$store.state.finalOrder;
            }
        },

        /**
         * Set brand in store to default state. In order to always have empty fields on create page.
         */
        beforeDestroy() {

            this.removeFinalOrder();
        }
    }

</script>